package main

import (
	"flag"
	"os"

	"github.com/m3tam3re/ordercollect/internal/handlers"
	"github.com/gin-gonic/gin"
)

func main() {
	var port string
	flag.StringVar(&port, "port", "8080", "Specify a port, default is 8080")
	flag.Parse()

	r := gin.Default()
	authorized := r.Group("/wk24", gin.BasicAuth(gin.Accounts{
	"wk24": os.Getenv("WK24_PASSWORD"),
	"lanakk": os.Getenv("LANAKK_PASSWORD"),
	}))
	authorized.GET("/addorders", handlers.Addorders)
	r.GET("/real/confirmshipment", handlers.ConfirmRealShipment)
	r.Run(":" + port)
}
